import java.awt.Shape;
import java.awt.geom.GeneralPath;
import java.util.Iterator;
  // Hier jeweils auskommentieren:
// import java.util.ArrayList;
// import java.util.LinkedList;
// import java.util.Vector;
import java.util.HashSet;
// import java.util.TreeSet;

/**
 * Eine Schrankwand, die manipuliert werden kann und sich selbst auf einer Leinwand zeichnet.
 */
public class Schrankwand extends Moebel
{
  // Hier jeweils auskommentieren:
  // ArrayList schraenke = new ArrayList();
  // LinkedList schraenke = new LinkedList();
  // Vector schraenke = new Vector();
  HashSet schraenke = new HashSet();
  // TreeSet schraenke = new TreeSet();  // hier gibt es irgendwie Stress beim Erzeugen. JAVA-Fehler?
  int anzahl;

  /**
   * Erzeuge eine neue Schrankwand mit einer Standardfarbe und Standardgroesse
   * an einer Standardposition.
   * Der Konstruktor muss die Zahl der Schrnke bergeben bekommen.
   */
    public Schrankwand(int anzahl)
  {
    xPosition = 40;
    yPosition = 80;
    farbe = "blau";
    orientierung = 0;
    istSichtbar = false;
    int schrankbreite = 60;
    this.anzahl = anzahl;
    breite = schrankbreite*anzahl;
    tiefe  = 37;
    for (int i=0;i<anzahl;i++){
        schraenke.add(new Schrank(i*schrankbreite, 0, farbe, orientierung, schrankbreite, tiefe));
    }
  }
  
  /**
   * Berechnet das zu zeichnende Shape anhand der gegebenen Daten
   */
  protected Shape gibAktuelleFigur()
  {
      GeneralPath schrankwand = new GeneralPath();
      for (Iterator<Schrank> it= schraenke.iterator();it.hasNext();){
        schrankwand.append(it.next().gibAktuelleFigur(), false);
      }
      
      return  transformiere(schrankwand);
  }
  
}
